// Original example by Hutch

    .intel_syntax noprefix
    .global _start

    .macro szByteCopy arg1,arg2
      push \arg2
      push \arg1
      call szcopy
    .endm

    .macro m2m arg1,arg2
      push \arg2
      pop  \arg1
    .endm

    .include "invoke.gi"
    .include "msgbox.imp" 

    .set MB_ICONASTERISK, 0x40
    .set MB_OK, 0x0

  // -----------------------
  // zero terminated strings
  // -----------------------

  .data
    message: .ascii "Its a GAS Its a GAS Its a GAS Its a GAS\n"
             .ascii "Its a GAS Its a GAS Its a GAS Its a GAS\n"
             .ascii "Its a GAS Its a GAS Its a GAS Its a GAS\x00"

    caption: .ascii "Hey man !\x00"

 // -----------------------------------
 // pointers to zero terminated strings
 // -----------------------------------
    pmsg: .long message
    pttl: .long caption

.text

/*  */

_start:

    .bss
      buffer: .fill 128         /*  128 byte buffer  */
    .data
      pbuf:   .long buffer      /* pointer to buffer */
    .text

    invoke GetCL,2,1,pbuf
    cmp eax, 1
    jne nocl

    invoke MessageBox,4,0,pbuf,pttl,MB_OK | MB_ICONASTERISK

    jmp quit

  nocl:
    .data
      nomsg: .ascii "No command line argument was entered\x00"
      nottl: .ascii "Sorry ....\x00"
      pnm: .long nomsg
      pnt: .long nottl
    .text
    invoke MessageBox,4,0,pnm,pnt,MB_OK | MB_ICONASTERISK

  quit:
    invoke ExitProcess,1,0

/*  */

  .align 8
  szcopy:

    mov ecx, [esp+4]
    mov edx, [esp+8]

    push ebx
    xor ebx, ebx

  cpy:
  .rept 3
    mov al, [ecx+ebx]
    mov [edx+ebx], al
    add ebx, 0x01
    test al, al
    jz cpout
  .endr

    mov al, [ecx+ebx]
    mov [edx+ebx], al
    add ebx, 0x01
    test al, al
    jnz cpy

  cpout:

    pop ebx

    ret 8

/*  */
